function ArenaLive_ComboPoints_OnLoad(self, comboPoint1, comboPoint2, comboPoint3, comboPoint4, comboPoint5)

	self.comboPoint1 = comboPoint1;
	self.comboPoint2 = comboPoint2;
	self.comboPoint3 = comboPoint3;
	self.comboPoint4 = comboPoint4;
	self.comboPoint5 = comboPoint5;
	
	self.lastNumComboPoints = 0;
	
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
	self:RegisterEvent("UNIT_COMBO_POINTS");
end



function ArenaLive_ComboPoints_UpdateUnit(self, unit)

	if ( (not self) or (not unit ) ) then
		return;
	end
	
	self.unit = unit;
	self:SetScript("OnEvent",  ArenaLive_ComboPoints_OnEvent);

end



function ArenaLive_ComboPoints_ResetFrame()
	
	self.unit = nil;
	self:SetScript("OnEvent",  nil);

end

function ArenaLive_ComboPoints_OnEvent(self, event, ...)
	
	local unit = select(1, ...);
	
	if ( event == "PLAYER_TARGET_CHANGED" ) then
		ArenaLive_ComboPoints_Update(self);
	elseif ( ( event == "UNIT_COMBO_POINTS" ) and ( unit == self.unit ) ) then
		ArenaLive_ComboPoints_Update(self);
	end

end



function ArenaLive_ComboPoints_Update(self)

	local comboPoints = GetComboPoints(self.unit, "target");
	local comboPointAnimation;
	
	if ( comboPoints > 0 ) then
		if ( not self:IsShown() ) then
			self:Show();
		end
		
		for i = 1, 5 do
			local comboPoint = self["comboPoint"..i];
			local comboPointName = comboPoint:GetName();
		
			if ( comboPointName ) then
			
				-- Always name your combo point show-animation "$parentFadeIn", if you want to create a custom one!
				comboPointAnimation = _G[comboPointName.."FadeIn"];
			end
			
			if ( i <= comboPoints ) then
				comboPoint:Show();
				
				if ( ( comboPointAnimation ) and (i > self.lastNumComboPoints ) ) then
					comboPoint:SetAlpha(0);
					comboPointAnimation:Play();
				end
			else
				comboPoint:Hide();	
			end
		end
	else
		self:Hide();
	end
	
	self.lastNumComboPoints = comboPoints;
end



function ArenaLive_ComboPoints_AnimationFinished(self, parent)

	parent:SetAlpha(1);

end