local addonName, L = ...;
ArenaLiveUnitFrames_Defaults =
{
	["options"] =
	{
		["version"] = "1.0",
		["showHealPrediction"] = true,
		["onlyShowCastableBuffs"] = false,
		["onlyShowDispellableDebuffs"] = false,
		["showAllEnemyDebuffs"] = true,
		["filterBuffsTournamentStyle"] = false,
		["hideBlizzCastBar"] = false,
	},
	["frameTypes"] =
	{
		["playerFrame"] =
		{
			["enabled"] = true,
			["anchor"] =
			{
				["point"] = "TOPLEFT",
				["relativeTo"] = "ArenaLiveUnitFrames",
				["relativePoint"] = "TOPLEFT",
				["xOffset"] = 19,
				["yOffset"] = -4,
			},
			["portraitType"] = "3D",
			["healthBarTextString"] = "%CURR_SHORT% / %MAX_SHORT% (%PERCENT_SHORT%%)",
			["powerBarTextString"] = "%CURR% / %MAX%",
			["healthBarColourMode"] = "none",
			["nameColourMode"] = "none",
			["icon1Type"] = "class",
			["icon2Type"] = "specialisation",
			["isLocked"] = true,
			["scale"] = 1.0,
			
			["castBar"] = {
				["isShown"] = true,
				["position"] = "BELOW";
			},
			["castHistory"] = {
				["isShown"] = true,
				["showTargetIndicator"] = true,
				["shownIcons"] = 6,
				["iconSize"] = 18,
			},
			["auraFrame"] = {
				["isShown"] = true,
				["position"] = "BELOW";
				["growUpwards"] = false,
				["iconSize"] = 17,		
				["largeIconSize"] = 21,
				["iconSpacing"] = 3,
				["maxShownBuffs"] = 32,
				["maxShownDebuffs"] = 16,
				["rtlAuras"] = false,
				
			},
		},
		["targetFrame"] =
		{
			["enabled"] = true,
			["anchor"] =
			{
				["point"] = "TOPLEFT",
				["relativeTo"] = "ArenaLiveUnitFrames",
				["relativePoint"] = "TOPLEFT",
				["xOffset"] = 250,
				["yOffset"] = -4,
			},
			["portraitType"] = "3D",
			["healthBarTextString"] = "%CURR_SHORT% / %MAX_SHORT% (%PERCENT_SHORT%%)",
			["powerBarTextString"] = "%CURR% / %MAX%",
			["healthBarColourMode"] = "none",
			["nameColourMode"] = "none",
			["icon1Type"] = "class",
			["icon2Type"] = "reaction",
			["isLocked"] = true,
			["scale"] = 1.0,
			
			["castBar"] = {
				["isShown"] = true,
				["position"] = "BELOW";
			},
			["castHistory"] = {
				["isShown"] = true,
				["showTargetIndicator"] = true,
				["shownIcons"] = 6,
				["iconSize"] = 18,
			},
			["auraFrame"] = {
				["isShown"] = true,
				["position"] = "BELOW";
				["growUpwards"] = false,
				["iconSize"] = 17,		
				["largeIconSize"] = 21,
				["iconSpacing"] = 3,
				["maxShownBuffs"] = 32,
				["maxShownDebuffs"] = 16,
				["rtlAuras"] = true,
				
			},
		},
		["targetOfTargetFrame"] =
		{
			["enabled"] = true,
			["anchor"] =
			{
				["point"] = "BOTTOMRIGHT",
				["relativeTo"] = "ALUF_TargetFrame",
				["relativePoint"] = "BOTTOMRIGHT",
				["xOffset"] = 38,
				["yOffset"] = 7,
			},
			["portraitType"] = "class",
			["nameColourMode"] = "none",
			["healthBarColourMode"] = "none",
			["isLocked"] = true,
			["scale"] = 1.0,
		},
		["petFrame"] =
		{
			["enabled"] = true,
			["anchor"] =
			{
				["point"] = "TOPLEFT",
				["relativeTo"] = "ArenaLiveUnitFrames",
				["relativePoint"] = "TOPLEFT",
				["xOffset"] = 19,
				["yOffset"] = -138,
			},
			["portraitType"] = "3D",
			["healthBarTextString"] = "%PERCENT_SHORT%%",
			["powerBarTextString"] = "%PERCENT_SHORT%%",
			["healthBarColourMode"] = "none",
			["nameColourMode"] = "none",
			["isLocked"] = true,
			["scale"] = 1.0,
			
			["castBar"] = {
				["isShown"] = true,
				["position"] = "BELOW";
			},
			["auraFrame"] = {
				["isShown"] = true,
				["position"] = "BELOW";
				["growUpwards"] = false,
				["iconSize"] = 14,		
				["largeIconSize"] = 18,
				["iconSpacing"] = 3,
				["maxShownBuffs"] = 0,
				["maxShownDebuffs"] = 4,
				["rtlAuras"] = false,
				
			},
		},
		["focusFrame"] =
		{
			["enabled"] = true,
			["anchor"] =
			{
				["point"] = "TOPLEFT",
				["relativeTo"] = "ArenaLiveUnitFrames",
				["relativePoint"] = "TOPLEFT",
				["xOffset"] = 250,
				["yOffset"] = -138,
			},
			["portraitType"] = "3D",
			["healthBarTextString"] = "%CURR_SHORT% / %MAX_SHORT% (%PERCENT_SHORT%%)",
			["powerBarTextString"] = "%CURR% / %MAX%",
			["healthBarColourMode"] = "none",
			["nameColourMode"] = "none",
			["icon1Type"] = "class",
			["icon2Type"] = "reaction",
			["isLocked"] = true,
			["scale"] = 1.0,
			
			["castBar"] = {
				["isShown"] = true,
				["position"] = "BELOW";
			},
			["castHistory"] = {
				["isShown"] = true,
				["showTargetIndicator"] = true,
				["shownIcons"] = 6,
				["iconSize"] = 18,
			},
			["auraFrame"] = {
				["isShown"] = true,
				["position"] = "BELOW";
				["growUpwards"] = false,
				["iconSize"] = 17,		
				["largeIconSize"] = 21,
				["iconSpacing"] = 3,
				["maxShownBuffs"] = 32,
				["maxShownDebuffs"] = 16,
				["rtlAuras"] = true,
				
			},
		},
		["targetOfFocusFrame"] =
		{
			["enabled"] = true,
			["anchor"] =
			{
				["point"] = "BOTTOMRIGHT",
				["relativeTo"] = "ALUF_FocusFrame",
				["relativePoint"] = "BOTTOMRIGHT",
				["xOffset"] = 38,
				["yOffset"] = 7,
			},
			["portraitType"] = "class",
			["nameColourMode"] = "none",
			["healthBarColourMode"] = "none",
			["isLocked"] = true,
			["scale"] = 1.0,
		},
		["arenaFrames"] =
		{
			["enabled"] = true,
			["anchor"] =
			{
				["point"] = "TOPRIGHT",
				["relativeTo"] = "ArenaLiveUnitFrames",
				["relativePoint"] = "TOPRIGHT",
				["xOffset"] = -200,
				["yOffset"] = -100,
			},
			["portraitType"] = "class",
			["healthBarTextString"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["powerBarTextString"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["healthBarColourMode"] = "none",
			["nameColourMode"] = "none",
			["icon1Type"] = "trinket",
			["icon2Type"] = "interruptOrDispel",
			["icon3Type"] = "specialisation",
			["isLocked"] = true,
			["scale"] = 1.0,
			["growUpwards"] = false,
			["frameSpacing"] = 10,
			["castBar"] = {
				["isShown"] = true,
				["position"] = "LEFT";
			},
			["castHistory"] = {
				["isShown"] = true,
				["showTargetIndicator"] = true,
				["shownIcons"] = 4,
				["iconSize"] = 21,
			},
			["drTracker"] = {
				["isShown"] = true,
				["position"] = "RIGHT",
				["iconSize"] = 32,
			},
		},
	},
};
ArenaLive_Database_UpdateAddOn(addonName, ArenaLiveUnitFrames_Defaults);



function ArenaLiveUnitFrames_OnLoad(self)
	
	-- Register Slash-Commands
	SLASH_ARENALIVEUNITFRAMES1, SLASH_ARENALIVEUNITFRAMES2, SLASH_ARENALIVEUNITFRAMES3 = "/aluf", "/aliveuf", "/arenaliveunitframes";
	self:RegisterEvent("ADDON_LOADED");
end

function  SlashCmdList.ARENALIVEUNITFRAMES(msg, editbox)

	InterfaceOptionsFrame_OpenToCategory(ALUF_Options);
end

function ArenaLiveUnitFrames_OnEvent(self, event, ...)
	
	if ( event == "ADDON_LOADED" and select(1,...) == addonName ) then
		ArenaLiveUnitFrames_AddOnLoaded();
	end
end



function ArenaLiveUnitFrames_AddOnLoaded()
	
	if (not ArenaLiveUnitFrames_SavedVariables ) then
		ArenaLiveUnitFrames_SavedVariables = ArenaLiveUnitFrames_Defaults;
	else
		-- Adds the new tables to existing savedVariables if needed.
		for key, value in pairs(ArenaLiveUnitFrames_Defaults["frameTypes"]) do

			if ( not ArenaLiveUnitFrames_SavedVariables["frameTypes"][key] ) then
				
				ArenaLiveUnitFrames_SavedVariables["frameTypes"][key] = value;
			
			end
			
		end
	end
	
	ArenaLive_Database_UpdateAddOn (addonName, ArenaLiveUnitFrames_SavedVariables);
	local point, relativeTo, relativePoint, xOffset, yOffset;
	
	-- PlayerFrame	
	point = ARENALIVE_DATABASE[addonName]["frameTypes"]["playerFrame"]["anchor"]["point"];
	relativeTo = ARENALIVE_DATABASE[addonName]["frameTypes"]["playerFrame"]["anchor"]["relativeTo"];
	relativePoint = ARENALIVE_DATABASE[addonName]["frameTypes"]["playerFrame"]["anchor"]["relativePoint"];
	xOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["playerFrame"]["anchor"]["xOffset"];
	yOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["playerFrame"]["anchor"]["yOffset"];	
	ALUF_PlayerFrame:ClearAllPoints();
	ALUF_PlayerFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);

	local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["playerFrame"]["scale"];
	ALUF_PlayerFrame:SetScale(scale);
	ALUF_PlayerFrame_Update(ALUF_PlayerFrame);
	
	PlayerFrame:SetScript("OnEvent", nil);
	
	
	-- TargetFrame
	point = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetFrame"]["anchor"]["point"];
	relativeTo = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetFrame"]["anchor"]["relativeTo"];
	relativePoint = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetFrame"]["anchor"]["relativePoint"];
	xOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetFrame"]["anchor"]["xOffset"];
	yOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetFrame"]["anchor"]["yOffset"];	
	ALUF_TargetFrame:ClearAllPoints();
	ALUF_TargetFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);

	local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetFrame"]["scale"];
	ALUF_TargetFrame:SetScale(scale);
	
	-- ToTFrame	
	point = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfTargetFrame"]["anchor"]["point"];
	relativeTo = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfTargetFrame"]["anchor"]["relativeTo"];
	relativePoint = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfTargetFrame"]["anchor"]["relativePoint"];
	xOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfTargetFrame"]["anchor"]["xOffset"];
	yOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfTargetFrame"]["anchor"]["yOffset"];	
	ALUF_TargetofTargetFrame:ClearAllPoints();
	ALUF_TargetofTargetFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);

	local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfTargetFrame"]["scale"];
	ALUF_TargetofTargetFrame:SetScale(scale);

	
	-- FocusFrame	
	point = ARENALIVE_DATABASE[addonName]["frameTypes"]["focusFrame"]["anchor"]["point"];
	relativeTo = ARENALIVE_DATABASE[addonName]["frameTypes"]["focusFrame"]["anchor"]["relativeTo"];
	relativePoint = ARENALIVE_DATABASE[addonName]["frameTypes"]["focusFrame"]["anchor"]["relativePoint"];
	xOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["focusFrame"]["anchor"]["xOffset"];
	yOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["focusFrame"]["anchor"]["yOffset"];	
	ALUF_FocusFrame:ClearAllPoints();
	ALUF_FocusFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);

	local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["focusFrame"]["scale"];
	ALUF_FocusFrame:SetScale(scale);
	
	FocusFrame:SetScript("OnEvent", nil);

	
	-- ToFFrame
	point = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfFocusFrame"]["anchor"]["point"];
	relativeTo = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfFocusFrame"]["anchor"]["relativeTo"];
	relativePoint = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfFocusFrame"]["anchor"]["relativePoint"];
	xOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfFocusFrame"]["anchor"]["xOffset"];
	yOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfFocusFrame"]["anchor"]["yOffset"];	
	ALUF_TargetofFocusFrame:ClearAllPoints();
	ALUF_TargetofFocusFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);

	local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["targetOfFocusFrame"]["scale"];
	ALUF_TargetofFocusFrame:SetScale(scale);
	ALUF_TargetOfTargetFrame_Toggle(ALUF_TargetofFocusFrame, "focus-target");
	
	-- PetFrame
	point = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["anchor"]["point"];
	relativeTo = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["anchor"]["relativeTo"];
	relativePoint = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["anchor"]["relativePoint"];
	xOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["anchor"]["xOffset"];
	yOffset = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["anchor"]["yOffset"];	
	ALUF_PetFrame:ClearAllPoints();
	ALUF_PetFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	ALUF_PetFrame_AdjustAttachments(ALUF_PetFrame);

	local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["scale"];
	ALUF_PetFrame:SetScale(scale);
	
	-- ArenaEnemyFrames
	local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["scale"];
	ALUF_ArenaEnemyFrames:SetScale(scale);
	for i = 1, 5 do
		local frame = _G["ALUF_ArenaEnemyFrame"..i];
		local unit = "arena"..i;
		ALUF_ArenaEnemyFrame_AdjustAttachments(frame, unit);
		ALUF_ArenaEnemyFrame_AdjustFramePosition(frame);
	end	
	
	-- Blizzard Castbar
	ArenaLive_ToggleBlizzFrame(CastingBarFrame, ARENALIVE_DATABASE[addonName]["options"]["hideBlizzCastBar"]);
end