local addonName, L = ...;

function ALUF_OptionsArenaEnemyFrame_OnLoad(self)
	-- Create a sub panel in ArenaLiveUnitFrame addon panel
	self.name= L["arenaFrames"];
	self.okay = ALUF_OptionsArenaEnemyFrame_Okay;
	self.cancel = ALUF_OptionsArenaEnemyFrame_Cancel;
	self.parent = "ArenaLiveUnitFrames";
	InterfaceOptions_AddCategory(self);	

	-- Set Localisation:
	ALUF_ArenaEnemyFrame_OptionsTitle:SetText(L["ALUFArenaFramesFrameTitle"]);
	ALUF_ArenaEnemyFrame_OptionsCastBarTitle:SetText(L["castBar:"]);
	ALUF_ArenaEnemyFrame_OptionsDrTrackerTitle:SetText(L["drTracker:"]);
	
	self:RegisterEvent("ADDON_LOADED");
end

function ALUF_OptionsArenaEnemyFrame_Initialise(self)
	local prefix = self:GetName();
	local checkbutton, editbox, slider, dropdown, selectedValue;
	
	-- Initialise Checkbuttons
	checkbutton = _G[prefix.."IsEnabled"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "enableFrame", "arenaFrames", nil, "enabled");
	
	checkbutton = _G[prefix.."IsLocked"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "lockFrame", "arenaFrames", nil, "isLocked");
	
	checkbutton = _G[prefix.."GrowUpwards"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "growFramesUpwards", "arenaFrames", nil, "growUpwards");
	
	checkbutton = _G[prefix.."ShowCastBar"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showCastbar", "arenaFrames", "castBar", "isShown");

	checkbutton = _G[prefix.."ShowCastHistory"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showCastHistory", "arenaFrames", "castHistory", "isShown");	

	checkbutton = _G[prefix.."ShowDrTracker"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showDrTracker", "arenaFrames", "drTracker", "isShown");
	
	checkbutton = nil;
	
	
	-- Initialise Editboxes
	editbox = _G[prefix.."HealthBarText"];
	ALUF_Options_EditBoxInitialise(editbox, "shownTextinHealthBar:", "arenaFrames", nil, "healthBarTextString");

	editbox = _G[prefix.."PowerBarText"];
	ALUF_Options_EditBoxInitialise(editbox, "shownTextinPowerBar:", "arenaFrames", nil, "powerBarTextString");
	
	-- Initialise Sliders
	slider = _G[prefix.."FrameScale"];
	slider.valueFactor = 0.1;
	ALUF_Options_SliderInitialise(slider, "frameScale", "arenaFrames", nil, "scale");

	slider = _G[prefix.."CastHistoryShownIcons"];
	ALUF_Options_SliderInitialise(slider, "maxCastHistoryIcons", "arenaFrames", "castHistory", "shownIcons");	
	
	slider = _G[prefix.."CastHistoryIconSize"];
	ALUF_Options_SliderInitialise(slider, "castHistoryIconSize", "arenaFrames", "castHistory", "iconSize");
		
	slider = _G[prefix.."DrTrackerIconSize"];
	ALUF_Options_SliderInitialise(slider, "drTrackerIconSize", "arenaFrames", "drTracker", "iconSize");

	slider = _G[prefix.."FrameSpacing"];
	ALUF_Options_SliderInitialise(slider, "spaceBetweenFrames", "arenaFrames", nil, "frameSpacing");	
	slider = nil;
	
	-- Initialise DropDown menus
	dropdown = _G[prefix.."PortraitType"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["portraitType"];
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."Icon1"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["icon1Type"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."Icon2"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["icon2Type"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."HealthBarColour"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["healthBarColourMode"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."NameColour"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["nameColourMode"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."CastBarPosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castBar"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."DrTrackerPosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["drTracker"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = nil;
	ArenaLive_FrameMover_UpdateVisible(ALUF_ArenaEnemyFramesMover);
	for i = 1, 5 do
		if ( not ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["isLocked"] ) then
			UnregisterUnitWatch(_G["ALUF_ArenaEnemyFrame"..i]);
			_G["ALUF_ArenaEnemyFrame"..i]:Show();
		else
			RegisterUnitWatch(_G["ALUF_ArenaEnemyFrame"..i]);
		end
	end
end

function ALUF_OptionsArenaEnemyFrame_OnEvent(self, event, ...)
	local arg1 = ...;
	
	if ( event == "ADDON_LOADED" and arg1 == addonName ) then
		ALUF_OptionsArenaEnemyFrame_Initialise(self)
	end

end

function ALUF_OptionsArenaEnemyFrame_OnShow(self)
	local prefix = self:GetName();
	local isEnabledCheckbutton = _G[prefix.."IsEnabled"];
	local framelockCheckbutton = _G[prefix.."IsLocked"];
	local frameScale = _G[prefix.."FrameScale"];
	if ( InCombatLockdown() ) then
		isEnabledCheckbutton:Disable();
		framelockCheckbutton:Disable();
		frameScale:Disable();
		ArenaLive_SystemMessage(L["inCombatLockdown"]);
	else
		isEnabledCheckbutton:Enable();
		framelockCheckbutton:Enable();
		frameScale:Enable();
	end
end


function ALUF_OptionsArenaEnemyFrame_Okay(self)
	local prefix = self:GetName();
	local frame;
	if ( not InCombatLockdown() ) then	
		-- CHECKBUTTONS
		frame = _G[prefix.."IsEnabled"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["enabled"] = frame:GetChecked();
		
		frame = _G[prefix.."IsLocked"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["isLocked"] = frame:GetChecked();

		frame = _G[prefix.."GrowUpwards"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["growUpwards"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowCastBar"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castBar"]["isShown"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowCastHistory"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castHistory"]["isShown"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowDrTracker"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["drTracker"]["isShown"] = frame:GetChecked();
		
		
		-- EDITBOXES
		frame = _G[prefix.."HealthBarText"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["healthBarTextString"] = frame:GetText();
		
		frame = _G[prefix.."PowerBarText"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["powerBarTextString"] = frame:GetText();
		
		
		-- SLIDERS
		frame = _G[prefix.."FrameScale"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["scale"] = ALUF_Options_SliderGetValue(frame);
		
		frame = _G[prefix.."CastHistoryShownIcons"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castHistory"]["shownIcons"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."FrameSpacing"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["frameSpacing"] = ALUF_Options_SliderGetValue(frame);		
		
		frame = _G[prefix.."CastHistoryIconSize"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castHistory"]["iconSize"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."DrTrackerIconSize"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["drTracker"]["iconSize"] = ALUF_Options_SliderGetValue(frame);
		
		
		-- DROPDOWN MENUS
		frame = _G[prefix.."PortraitType"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["portraitType"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."Icon1"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["icon1Type"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."Icon2"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["icon2Type"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."HealthBarColour"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["healthBarColourMode"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."NameColour"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["nameColourMode"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."CastBarPosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castBar"]["position"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."DrTrackerPosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["drTracker"]["position"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = nil;
		
		-- Updapte the frame and saved variables
		ArenaLive_Database_UpdateSavedVariables(addonName, ArenaLiveUnitFrames_SavedVariables);

		local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["scale"];

		ALUF_ArenaEnemyFrames:SetScale(scale);
		ArenaLive_FrameMover_UpdateVisible(ALUF_ArenaEnemyFramesMover);
		for i = 1, 5 do
			ArenaLive_UnitFrame_Update(_G["ALUF_ArenaEnemyFrame"..i]);
			ArenaLive_Icon_Update(_G["ALUF_ArenaEnemyFrame"..i.."Icon1"]);
			ArenaLive_Icon_Update(_G["ALUF_ArenaEnemyFrame"..i.."Icon2"]);
			ALUF_ArenaEnemyFrame_AdjustAttachments(_G["ALUF_ArenaEnemyFrame"..i]);
			ALUF_ArenaEnemyFrame_AdjustFramePosition(_G["ALUF_ArenaEnemyFrame"..i]);		
			if ( not _G[prefix.."IsLocked"]:GetChecked() ) then
				UnregisterUnitWatch(_G["ALUF_ArenaEnemyFrame"..i]);
				_G["ALUF_ArenaEnemyFrame"..i]:Show();
			else
				RegisterUnitWatch(_G["ALUF_ArenaEnemyFrame"..i]);
			end
		end
	else
		ALUF_OptionsArenaEnemyFrame_Cancel(self)
	end
end



function ALUF_OptionsArenaEnemyFrame_Cancel(self)
	
	local prefix = self:GetName();
	local frame;
	
	-- CHECKBUTTONS
	frame = _G[prefix.."IsEnabled"];
	frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["enabled"]);
	
	frame = _G[prefix.."IsLocked"];
	frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["isLocked"]);
	
	frame = _G[prefix.."GrowUpwards"];
	frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["growUpwards"]);
	
	frame = _G[prefix.."ShowCastBar"];
	frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castBar"]["isShown"]);
	
	frame = _G[prefix.."ShowCastHistory"];
	frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castHistory"]["isShown"]);
	
	frame = _G[prefix.."ShowDrTracker"];
	frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["drTracker"]["isShown"]);
	
	
	-- EDITBOXES
	frame = _G[prefix.."HealthBarText"];
	frame:SetText(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["healthBarTextString"]);
	
	frame = _G[prefix.."PowerBarText"];
	frame:SetText(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["powerBarTextString"]);
	
	
	-- SLIDERS
	frame = _G[prefix.."FrameScale"];
	ALUF_Options_SliderSetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["scale"]);
		
	frame = _G[prefix.."CastHistoryShownIcons"];
	frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castHistory"]["shownIcons"]);

	frame = _G[prefix.."DrTrackerIconSize"];
	frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["drTracker"]["iconSize"]);

	frame = _G[prefix.."FrameSpacing"];
	frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["frameSpacing"]);
	
	-- DROPDOWN MENUS
	frame = _G[prefix.."PortraitType"];
	UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["portraitType"]);
	
	frame = _G[prefix.."Icon1"];
	UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["icon1Type"]);
	
	frame = _G[prefix.."Icon2"];
	UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["icon2Type"]);
	
	frame = _G[prefix.."HealthBarColour"];
	UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["healthBarColourMode"]);
	
	frame = _G[prefix.."NameColour"];
	UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["nameColourMode"]);
	
	frame = _G[prefix.."CastBarPosition"];
	UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["castBar"]["position"]);
	
	frame = _G[prefix.."DrTrackerPosition"];
	UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["arenaFrames"]["drTracker"]["position"]);
	
	frame = nil;
end